diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/DefaultSettingNodes.java b/game/core/src/main/java/net/minecraft/core/world/settings/DefaultSettingNodes.java
new file mode 100644
index 000000000..80b4b8650
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/DefaultSettingNodes.java
@@ -0,0 +1,31 @@
+package net.minecraft.core.world.settings;
+
+import net.minecraft.core.lang.text.TranslatableText;
+import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.settings.impl.SeasonSettingNode;
+import org.jetbrains.annotations.NotNull;
+
+public final class DefaultSettingNodes {
+    private DefaultSettingNodes() throws IllegalAccessException {
+        throw new IllegalAccessException("No DefaultSettingNodes for you!");
+    }
+
+    private static final @NotNull SettingNode ROOT_NODE;
+    static {
+        ROOT_NODE = new ContainerSettingNode(
+            new ListSettingNodeChildrenProvider()
+                .withChildren(
+                    new SeasonSettingNode("minecraft:world_settings/single_season", new TranslatableText("world_settings.single_season.name"), SeasonSettingNode.DISABLED)
+                        .withValue(new SeasonSettingNode.SeasonEntry(Seasons.OVERWORLD_SPRING))
+                        .withValue(new SeasonSettingNode.SeasonEntry(Seasons.OVERWORLD_SUMMER))
+                        .withValue(new SeasonSettingNode.SeasonEntry(Seasons.OVERWORLD_FALL))
+                        .withValue(new SeasonSettingNode.SeasonEntry(Seasons.OVERWORLD_WINTER))
+                        .withValue(new SeasonSettingNode.SeasonEntry(Seasons.OVERWORLD_WINTER_ENDLESS))
+                )
+        );
+    }
+
+    public static @NotNull SettingNode getRootNode() {
+        return ROOT_NODE;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/EnumValueGenericSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/EnumValueGenericSettingNode.java
new file mode 100644
index 000000000..1a5e312d4
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/EnumValueGenericSettingNode.java
@@ -0,0 +1,11 @@
+package net.minecraft.core.world.settings;
+
+import net.minecraft.core.lang.text.IntoText;
+import net.minecraft.core.lang.text.Text;
+import org.jetbrains.annotations.NotNull;
+
+public class EnumValueGenericSettingNode<T extends Enum<T> & IntoText> extends ValueGenericSettingNode<T> {
+    public EnumValueGenericSettingNode(final @NotNull String key, final @NotNull Text name, final @NotNull T value) {
+        super(key, name, value);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/GenericSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/GenericSettingNode.java
new file mode 100644
index 000000000..58cabe811
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/GenericSettingNode.java
@@ -0,0 +1,55 @@
+package net.minecraft.core.world.settings;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public abstract class GenericSettingNode implements KeyedSettingNode {
+    private final @NotNull String key;
+    private @Nullable SettingNodeChildrenProvider childrenProvider = null;
+    private @NotNull SettingNodeVisibilityListener selfVisibilityListener = SettingNodeVisibilityListener::alwaysVisible;
+    private @NotNull SettingNodeVisibilityListener childrenVisibilityListener = SettingNodeVisibilityListener::alwaysVisible;
+
+    public GenericSettingNode(final @NotNull String key) {
+        this.key = key;
+
+        KeyedSettingNode.checkKeyIsUnique(key);
+    }
+
+    @Override
+    public @NotNull String getKey() {
+        return this.key;
+    }
+
+    @Override
+    public @Nullable SettingNodeChildrenProvider getChildrenProvider() {
+        return this.childrenProvider;
+    }
+
+    public final @NotNull GenericSettingNode withChildrenProvider(final @NotNull SettingNodeChildrenProvider childrenProvider) {
+        this.childrenProvider = childrenProvider;
+
+        return this;
+    }
+
+    @Override
+    public boolean isVisible(final @NotNull WorldConfiguration worldConfiguration) {
+        return this.selfVisibilityListener.isVisible(worldConfiguration);
+    }
+
+    public final @NotNull GenericSettingNode withVisibilityListener(final @NotNull SettingNodeVisibilityListener visibilityListener) {
+        this.selfVisibilityListener = visibilityListener;
+
+        return this;
+    }
+
+    @Override
+    public boolean areChildrenVisible(final @NotNull WorldConfiguration worldConfiguration) {
+        return this.isVisible(worldConfiguration) && this.childrenVisibilityListener.isVisible(worldConfiguration);
+    }
+
+    public final @NotNull GenericSettingNode withChildrenVisibilityListener(final @NotNull SettingNodeVisibilityListener visibilityListener) {
+        this.childrenVisibilityListener = visibilityListener;
+
+        return this;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/KeyedSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/KeyedSettingNode.java
new file mode 100644
index 000000000..1237e1b4e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/KeyedSettingNode.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.world.settings;
+
+import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Set;
+
+public interface KeyedSettingNode extends SettingNode {
+    @NotNull Set<@NotNull String> SETTING_KEYS = new ObjectOpenHashSet<>();
+
+    static void checkKeyIsUnique(final @NotNull String key) {
+        if (SETTING_KEYS.contains(key)) {
+            throw new IllegalStateException("Key already exists!");
+        }
+
+        SETTING_KEYS.add(key);
+    }
+
+    @NotNull String getKey();
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ListSettingNodeChildrenProvider.java b/game/core/src/main/java/net/minecraft/core/world/settings/ListSettingNodeChildrenProvider.java
new file mode 100644
index 000000000..77dbd7164
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ListSettingNodeChildrenProvider.java
@@ -0,0 +1,48 @@
+package net.minecraft.core.world.settings;
+
+import it.unimi.dsi.fastutil.objects.Object2ObjectLinkedOpenHashMap;
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Iterator;
+import java.util.List;
+import java.util.Map;
+
+public class ListSettingNodeChildrenProvider implements SettingNodeChildrenProvider {
+    private final @NotNull List<@NotNull SettingNode> children = new ObjectArrayList<>();
+    private final @NotNull Map<@NotNull String, @NotNull KeyedSettingNode> keyedChildren = new Object2ObjectOpenHashMap<>();
+
+    @Override
+    public int length(final @NotNull WorldConfiguration worldConfiguration) {
+        return this.children.size();
+    }
+
+    @Override
+    public @NotNull Iterator<@NotNull SettingNode> getChildren(final @NotNull WorldConfiguration worldConfiguration) {
+        return this.children.iterator();
+    }
+
+    @Override
+    public @Nullable KeyedSettingNode getChildByKey(final @NotNull String key, final @NotNull WorldConfiguration worldConfiguration) {
+        return this.keyedChildren.get(key);
+    }
+
+    public final @NotNull ListSettingNodeChildrenProvider withChild(final @NotNull SettingNode settingNode) {
+        this.children.add(settingNode);
+        if (settingNode instanceof final @NotNull KeyedSettingNode keyed) {
+            this.keyedChildren.put(keyed.getKey(), keyed);
+        }
+
+        return this;
+    }
+
+    public final @NotNull ListSettingNodeChildrenProvider withChildren(final @NotNull SettingNode @NotNull ... settingNodes) {
+        for (final @NotNull SettingNode settingNode : settingNodes) {
+            this.withChild(settingNode);
+        }
+
+        return this;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ListValueGenericSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/ListValueGenericSettingNode.java
new file mode 100644
index 000000000..e2f31436f
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ListValueGenericSettingNode.java
@@ -0,0 +1,28 @@
+package net.minecraft.core.world.settings;
+
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
+import net.minecraft.core.lang.text.IntoText;
+import net.minecraft.core.lang.text.Text;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.List;
+
+public class ListValueGenericSettingNode<T extends IntoText> extends ValueGenericSettingNode<T> {
+    private final @NotNull List<@NotNull T> values = new ObjectArrayList<>();
+
+    public ListValueGenericSettingNode(final @NotNull String key, final @NotNull Text name, final @NotNull T defaultValue) {
+        super(key, name, defaultValue);
+
+        this.values.add(defaultValue);
+    }
+
+    public @NotNull List<T> getValues() {
+        return this.values;
+    }
+
+    public @NotNull ListValueGenericSettingNode<T> withValue(final @NotNull T value) {
+        this.values.add(value);
+
+        return this;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/NamedSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/NamedSettingNode.java
new file mode 100644
index 000000000..652dbf059
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/NamedSettingNode.java
@@ -0,0 +1,8 @@
+package net.minecraft.core.world.settings;
+
+import net.minecraft.core.lang.text.Text;
+import org.jetbrains.annotations.NotNull;
+
+public interface NamedSettingNode extends SettingNode {
+    @NotNull Text getName();
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/PercentageValueGenericSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/PercentageValueGenericSettingNode.java
new file mode 100644
index 000000000..61ce58557
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/PercentageValueGenericSettingNode.java
@@ -0,0 +1,26 @@
+package net.minecraft.core.world.settings;
+
+import net.minecraft.core.lang.text.LiteralText;
+import net.minecraft.core.lang.text.Text;
+import org.jetbrains.annotations.NotNull;
+
+public class PercentageValueGenericSettingNode extends ValueGenericSettingNode<@NotNull Float> implements RangeValueSettingNode<@NotNull Float> {
+    public PercentageValueGenericSettingNode(final @NotNull String key, final @NotNull Text name, final float defaultValue) {
+        super(key, name, defaultValue);
+    }
+
+    @Override
+    public @NotNull Float getMinimum(final @NotNull WorldConfiguration worldConfiguration) {
+        return 0.0f;
+    }
+
+    @Override
+    public @NotNull Float getMaximum(final @NotNull WorldConfiguration worldConfiguration) {
+        return 1.0f;
+    }
+
+    @Override
+    public @NotNull Text getValueText(final @NotNull Float value) {
+        return new LiteralText((int)(value * 100.0) + "%");
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/RangeValueSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/RangeValueSettingNode.java
new file mode 100644
index 000000000..324ae2e89
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/RangeValueSettingNode.java
@@ -0,0 +1,8 @@
+package net.minecraft.core.world.settings;
+
+import org.jetbrains.annotations.NotNull;
+
+public interface RangeValueSettingNode<T> extends ValueSettingNode<T> {
+    @NotNull T getMinimum(final @NotNull WorldConfiguration worldConfiguration);
+    @NotNull T getMaximum(final @NotNull WorldConfiguration worldConfiguration);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNode.java
new file mode 100644
index 000000000..b7811ee47
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNode.java
@@ -0,0 +1,34 @@
+package net.minecraft.core.world.settings;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Iterator;
+
+public interface SettingNode {
+    @Nullable SettingNodeChildrenProvider getChildrenProvider();
+
+    boolean isVisible(final @NotNull WorldConfiguration worldConfiguration);
+
+    boolean areChildrenVisible(final @NotNull WorldConfiguration worldConfiguration);
+
+    default @Nullable KeyedSettingNode getChildByKey(final @NotNull String key, final @NotNull WorldConfiguration worldConfiguration) {
+        final @Nullable SettingNodeChildrenProvider childrenProvider = this.getChildrenProvider();
+        if (childrenProvider != null) {
+            final @Nullable KeyedSettingNode myChild = childrenProvider.getChildByKey(key, worldConfiguration);
+            if (myChild != null) {
+                return myChild;
+            }
+            
+            for (final @NotNull Iterator<@NotNull SettingNode> it = childrenProvider.getChildren(worldConfiguration); it.hasNext(); ) {
+                final @NotNull SettingNode child = it.next();
+                final @Nullable KeyedSettingNode childsChild = child.getChildByKey(key, worldConfiguration); // recursion here
+                if (childsChild != null) {
+                    return childsChild;
+                }
+            }
+        }
+
+        return null;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeChildrenProvider.java b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeChildrenProvider.java
new file mode 100644
index 000000000..c5794c923
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeChildrenProvider.java
@@ -0,0 +1,14 @@
+package net.minecraft.core.world.settings;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Iterator;
+
+public interface SettingNodeChildrenProvider {
+    int length(final @NotNull WorldConfiguration worldConfiguration);
+
+    @NotNull Iterator<@NotNull SettingNode> getChildren(final @NotNull WorldConfiguration worldConfiguration);
+
+    @Nullable KeyedSettingNode getChildByKey(final @NotNull String key, final @NotNull WorldConfiguration worldConfiguration);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeList.java b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeList.java
new file mode 100644
index 000000000..a7fb4c0f2
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeList.java
@@ -0,0 +1,4 @@
+package net.minecraft.core.world.settings;
+
+public class SettingNodeList {
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeVisibilityListener.java b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeVisibilityListener.java
new file mode 100644
index 000000000..d62f53896
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodeVisibilityListener.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.world.settings;
+
+import org.jetbrains.annotations.NotNull;
+
+public interface SettingNodeVisibilityListener {
+    boolean isVisible(final @NotNull WorldConfiguration worldConfiguration);
+
+    @SuppressWarnings("unused")
+    static boolean alwaysVisible(final @NotNull WorldConfiguration worldConfiguration) {
+        return true;
+    }
+
+    @SuppressWarnings("unused")
+    static boolean neverVisible(final @NotNull WorldConfiguration worldConfiguration) {
+        return false;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodesValues.java b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodesValues.java
new file mode 100644
index 000000000..558498999
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/SettingNodesValues.java
@@ -0,0 +1,78 @@
+package net.minecraft.core.world.settings;
+
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Map;
+
+public class SettingNodesValues {
+    private final @NotNull SettingNode rootNode;
+    private final @NotNull Map<@NotNull ValueSettingNode<?>, @NotNull Object> keyedNodeValues = new Object2ObjectOpenHashMap<>();
+    private final @NotNull Map<@NotNull String, @NotNull ValueSettingNode<?>> nodesByKey = new Object2ObjectOpenHashMap<>();
+
+    public SettingNodesValues(final @NotNull SettingNode rootNode) {
+        this.rootNode = rootNode;
+    }
+
+    public @NotNull SettingNode getRootNode() {
+        return this.rootNode;
+    }
+
+    @SuppressWarnings("unchecked")
+    public <T> @NotNull T getNodeValue(final @NotNull ValueSettingNode<T> node) {
+        final @Nullable T value = (T) this.keyedNodeValues.get(node);
+        if (value != null) {
+            return value;
+        }
+
+        final @NotNull T defaultValue = node.getDefaultValue();
+        this.keyedNodeValues.put(node, node.getDefaultValue());
+        this.nodesByKey.put(node.getKey(), node);
+
+        return defaultValue;
+    }
+
+    @SuppressWarnings("unchecked")
+    public <T> @NotNull T getNodeValue(final @NotNull String key, final @NotNull Class<T> valueClass, final @NotNull WorldConfiguration worldConfiguration) {
+        @Nullable ValueSettingNode<?> node = this.nodesByKey.get(key);
+        if (node == null) {
+            final @Nullable KeyedSettingNode keyedSettingNode = this.rootNode.getChildByKey(key, worldConfiguration);
+            if (keyedSettingNode instanceof final @NotNull ValueSettingNode<?> nodeByKeyFromRoot) {
+                node = nodeByKeyFromRoot;
+            } else {
+                throw new IllegalArgumentException("Node does not have a value!");
+            }
+        }
+
+        if (!(valueClass.isAssignableFrom(node.getValueClass()))) {
+            throw new IllegalArgumentException("Node type " + node.getValueClass().getSimpleName() + " does not equal requested type " + valueClass.getSimpleName() + "!");
+        }
+
+        return (T) this.getNodeValue(node);
+    }
+
+    public <T> void setNodeValue(final @NotNull ValueSettingNode<T> node, final @NotNull T value) {
+        this.keyedNodeValues.put(node, value);
+        this.nodesByKey.put(node.getKey(), node);
+    }
+
+    @SuppressWarnings("unchecked")
+    public <T> void setNodeValue(final @NotNull String key, final @NotNull T value, final @NotNull WorldConfiguration worldConfiguration) {
+        @Nullable ValueSettingNode<?> node = this.nodesByKey.get(key);
+        if (node == null) {
+            final @Nullable KeyedSettingNode keyedSettingNode = this.rootNode.getChildByKey(key, worldConfiguration);
+            if (keyedSettingNode instanceof final @NotNull ValueSettingNode<?> nodeByKeyFromRoot) {
+                node = nodeByKeyFromRoot;
+            } else {
+                throw new IllegalArgumentException("Node does not have a value!");
+            }
+        }
+
+        if (!(value.getClass().isAssignableFrom(node.getValueClass()))) {
+            throw new IllegalArgumentException("Node type " + node.getValueClass().getSimpleName() + " does not equal requested type " + value.getClass().getSimpleName() + "!");
+        }
+
+        this.setNodeValue((ValueSettingNode<T>) node, value);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ValueGenericSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/ValueGenericSettingNode.java
new file mode 100644
index 000000000..6ec1dc0a2
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ValueGenericSettingNode.java
@@ -0,0 +1,45 @@
+package net.minecraft.core.world.settings;
+
+import net.minecraft.core.lang.text.IntoText;
+import net.minecraft.core.lang.text.LiteralText;
+import net.minecraft.core.lang.text.Text;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Objects;
+
+public class ValueGenericSettingNode<T> extends GenericSettingNode implements ValueSettingNode<T> {
+    private final @NotNull Text name;
+    private final @NotNull T value;
+
+    public ValueGenericSettingNode(final @NotNull String key, final @NotNull Text name, final @NotNull T defaultValue) {
+        super(key);
+
+        this.name = name;
+        this.value = defaultValue;
+    }
+
+    @Override
+    @SuppressWarnings("unchecked")
+    public @NotNull Class<@NotNull T> getValueClass() {
+        return (Class<@NotNull T>) this.value.getClass();
+    }
+
+    @Override
+    public final @NotNull T getDefaultValue() {
+        return this.value;
+    }
+
+    @Override
+    public @NotNull Text getValueText(final @NotNull T value) {
+        if (value instanceof final @NotNull IntoText intoText) {
+            return intoText.intoText();
+        } else {
+            return new LiteralText(Objects.requireNonNull(value.toString()));
+        }
+    }
+
+    @Override
+    public @NotNull Text getName() {
+        return this.name;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/ValueSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/ValueSettingNode.java
new file mode 100644
index 000000000..ea2c3e7d0
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/ValueSettingNode.java
@@ -0,0 +1,12 @@
+package net.minecraft.core.world.settings;
+
+import net.minecraft.core.lang.text.Text;
+import org.jetbrains.annotations.NotNull;
+
+public interface ValueSettingNode<T> extends SettingNode, NamedSettingNode, KeyedSettingNode {
+    @NotNull Class<@NotNull T> getValueClass();
+
+    @NotNull T getDefaultValue();
+
+    @NotNull Text getValueText(final @NotNull T value);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java b/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
index c3f680d41..9f2cdfb7b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
@@ -24,7 +24,8 @@ public class WorldConfiguration {
     private @NotNull WorldTypeGroups.Group worldTypeGroup = WorldTypeGroups.DEFAULT;
     private @Nullable Biome startingBiome = null;
     private final @NotNull GameRuleCollection gameRuleCollection = new GameRuleCollection();
-    private final SpawnerConfig spawnerConfig = new SpawnerConfig();
+    private final @NotNull SpawnerConfig spawnerConfig = new SpawnerConfig();
+    private final @NotNull SettingNodesValues settingNodesValues = new SettingNodesValues(DefaultSettingNodes.getRootNode());
 
     public WorldConfiguration() {
     }
@@ -118,6 +119,10 @@ public class WorldConfiguration {
         return this.startingBiome;
     }
 
+    public @NotNull SettingNodesValues getSettingNodesValues() {
+        return this.settingNodesValues;
+    }
+
     public @NotNull String getFolderName(final @NotNull ISaveFormat saveFormat) {
         final char @NotNull [] ac = ChatAllowedCharacters.ALLOWED_CHARACTERS_ARRAY;
         @NotNull String folderName = this.worldName.trim();
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/impl/SeasonSettingNode.java b/game/core/src/main/java/net/minecraft/core/world/settings/impl/SeasonSettingNode.java
new file mode 100644
index 000000000..a0457deb2
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/impl/SeasonSettingNode.java
@@ -0,0 +1,38 @@
+package net.minecraft.core.world.settings.impl;
+
+import net.minecraft.core.lang.text.IntoText;
+import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.lang.text.TranslatableText;
+import net.minecraft.core.world.season.Season;
+import net.minecraft.core.world.settings.ListValueGenericSettingNode;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class SeasonSettingNode extends ListValueGenericSettingNode<SeasonSettingNode.SeasonEntry> {
+    public static class SeasonEntry implements IntoText {
+        private final @NotNull Text text;
+
+        public final @Nullable Season season;
+
+        private SeasonEntry() {
+            this.season = null;
+            this.text = new TranslatableText("world_settings.single_season.disabled");
+        }
+
+        public SeasonEntry(final @NotNull Season season) {
+            this.season = season;
+            this.text = new TranslatableText(season.getLanguageKey());
+        }
+
+        @Override
+        public @NotNull Text intoText() {
+            return this.text;
+        }
+    }
+
+    public static final @NotNull SeasonEntry DISABLED = new SeasonEntry();
+
+    public SeasonSettingNode(final @NotNull String key, final @NotNull Text name, final @NotNull SeasonEntry defaultValue) {
+        super(key, name, defaultValue);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
index ec6ac3dcc..12ac246e3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
@@ -3,7 +3,9 @@ package net.minecraft.core.world.weather;
 import net.minecraft.core.Global;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.season.Season;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -160,12 +162,12 @@ public class WeatherManager {
             this.weatherDuration = getRandomWeatherDuration();
         }
 
-        this.world.dimensionData.setCurrentWeather(this.currentWeather);
-        this.world.dimensionData.setNextWeather(this.nextWeather);
-
-        this.world.dimensionData.setWeatherDuration(this.weatherDuration);
-        this.world.dimensionData.setWeatherIntensity(this.weatherIntensity);
-        this.world.dimensionData.setWeatherPower(this.weatherPower);
+        final @NotNull DimensionData dimensionData = this.world.getDimensionData();
+        dimensionData.setCurrentWeather(this.currentWeather);
+        dimensionData.setNextWeather(this.nextWeather);
+        dimensionData.setWeatherDuration(this.weatherDuration);
+        dimensionData.setWeatherIntensity(this.weatherIntensity);
+        dimensionData.setWeatherPower(this.weatherPower);
 
         return true;
     }
diff --git a/game/core/src/main/resources/lang/en_US/gui.lang b/game/core/src/main/resources/lang/en_US/gui.lang
index c688f7e61..3edc9f344 100644
--- a/game/core/src/main/resources/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/lang/en_US/gui.lang
@@ -229,10 +229,10 @@ gui.options.page.accessibility.title=Accessibility
 gui.options.page.accessibility.category.accessibility=Accessibility
 
 gui.options.page.video.title=Video
-gui.options.page.video.category.graphics=Graphics
-gui.options.page.video.category.performance=Performance
-gui.options.page.video.category.post_processing=Post-Processing
+gui.options.page.video.category.display=Display
 gui.options.page.video.category.visuals=Visuals
+gui.options.page.video.category.post_processing=Post-Processing
+gui.options.page.video.category.performance=Performance
 
 gui.options.page.controls.title=Controls
 gui.options.page.controls.button.controller_setup=Controller Setup...
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index 30570490f..81f0ab46d 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -78,7 +78,7 @@ import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveConverters;
 import net.minecraft.core.world.save.SaveFormats;
-import net.minecraft.core.world.save.SaveHandlerServer;
+import net.minecraft.core.world.save.LevelStorageServer;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
@@ -106,9 +106,7 @@ import net.minecraft.server.net.command.commands.CommandWhoIs;
 import net.minecraft.server.world.ConvertProgressUpdater;
 import net.minecraft.server.world.WorldManager;
 import net.minecraft.server.world.WorldServer;
-import net.minecraft.server.world.WorldServerMulti;
 import net.minecraft.server.world.chunk.provider.ChunkProviderServer;
-import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
@@ -519,7 +517,7 @@ public class MinecraftServer
 
                     levelDataTag.putInt("version", toWorldFormat.getSaveVersion());
 
-                    LevelStorage saveHandler = toWorldFormat.getSaveHandler(worldDirName, false);
+                    LevelStorage saveHandler = toWorldFormat.getLevelStorage(worldDirName, false);
                     saveHandler.saveLevelDataRaw(levelDataTag);
                 }
             }
@@ -531,19 +529,18 @@ public class MinecraftServer
     {
         convertWorld(saveFormat, worldDirName);
         dimensionWorlds = new Int2ObjectArrayMap<>();
-        SaveHandlerServer saveHandler = new SaveHandlerServer(saveFormat, new File("."), worldDirName, true);
+        LevelStorageServer saveHandler = new LevelStorageServer(saveFormat, new File("."), worldDirName, true);
         for (Int2ObjectMap.Entry<Dimension> entry : Dimension.getDimensionList().int2ObjectEntrySet())
         {
             int dimId = entry.getIntKey();
-            Dimension dimension = entry.getValue();
             WorldServer worldServer;
             if (dimId == 0)
             {
-                worldServer = new WorldServer(this, saveHandler, worldDirName, dimId, defaultWorldType, l);
+                worldServer = new WorldServer(this, saveHandler, worldDirName, dimId, l);
             }
             else
             {
-                worldServer = new WorldServerMulti(this, saveHandler, worldDirName, dimId, dimension.defaultWorldType, l, dimensionWorlds.get(0));
+                worldServer = new WorldServer(this, dimensionWorlds.get(0), dimId);
             }
             dimensionWorlds.put(dimId, worldServer);
             worldServer.addListener(new WorldManager(this, dimensionWorlds.get(dimId)));
